<?php
/**
* Conect the api, to confirm the payment.
*/
include(dirname(__FILE__).'/../../config/config.inc.php');
include_once(dirname(__FILE__).'/../../init.php');
class bnplNotificationModuleFrontController extends ModuleFrontController
{
    public $ssl = true;
    public $display_column_left = false;
    public $display_column_right = false;
    public $display_header=false;
    public $display_footer=false;

    public function postProcess()
    {
        parent::initContent();
        /**
        * get the data from the json.
        */
        $data = json_decode(file_get_contents('php://input'), true);
        $pv_po_id =$data["pv_po_id"];
        $po_id = $data["po_id"];
        $status = $data["status"];
        $pv_checksum = $data["pv_checksum"];
        $bnpl = Module::getInstanceByName('bnpl');
        $api_key = $bnpl->get_api_key();
        $id_order = Order::getOrderByCartId($po_id);
		$order = new Order($id_order);
        $signature_hash = hash('sha256',$po_id.$status.$api_key);
        $environment = $bnpl->get_mode();
		$environment_name = (1 == $environment)
            ? 'Produccion'
            : 'SandBox';
        /**
        * validate the credentials and change the status.
        */
        if($signature_hash==$pv_checksum){
            switch($status){
                case "pending":
                    $payment_status = Configuration::get('PS_OS_PREPARATION');
                break;
                case "approved":
                    $payment_status = Configuration::get('PS_OS_PAYMENT');
                break;
                case "expired":
                    $payment_status = Configuration::get('PS_OS_CANCELED');
                break;
                case "cancelled":
                    $payment_status = Configuration::get('PS_OS_CANCELED');
                break;
                default:
                    $payment_status = Configuration::get('PS_OS_PREPARATION');
            }
            $order->setCurrentState($payment_status);
            echo "ok";
        }else{
            echo "fallo en la firma electronica";
        }
    }
}
